/*!\file ControlConstrainx
 * \brief constrain optimization parameters during inverse method
 */

#include "./ControlConstrainx.h"

#undef __FUNCT__ 
#define __FUNCT__ "ControlConstrainx"

#include "../shared/shared.h"
#include "../include/macros.h"
#include "../toolkits/toolkits.h"
#include "../EnumDefinitions/EnumDefinitions.h"

void ControlConstrainx( double* p_g, int numdofnodes, double cm_min, double cm_max,char* control_type){

	int i;
	
	if(isnan(cm_min) & isnan(cm_max)){
		/*do nothing*/
	}
	else{
		for(i=0;i<numdofnodes;i++){
			if(isnan(p_g[i])){
				throw ErrorException(__FUNCT__,exprintf("NaN found in parameter p_g[%i]",i));
			}
			if(!isnan(cm_min)){
				if (p_g[i]<cm_min)p_g[i]=cm_min;
			}
			if(!isnan(cm_max)){
				if (p_g[i]>cm_max)p_g[i]=cm_max;
			}
		}
	}
		
}
